#include "button.h"

BUTTON::BUTTON(byte pin) {
  _pin = pin;
  pinMode(_pin, INPUT_PULLUP);
  _stateS = HIGH;
  _stateL = HIGH;
  _prevTime = millis();
}

btnState BUTTON::isChanged(void) {
  btnState res = bsNone;
  unsigned long currTime = millis();

  if (!digitalRead(_pin)) {
    if (_stateS && ((currTime - _prevTime) > DEBOUNCE_DELAY)) {
       _prevTime = currTime;
       _stateS = LOW;
       _stateL = HIGH;
    }

    if (_stateL && ((currTime - _prevTime) > LONG_PRESS)) {
      _stateL = LOW;
      res = bsLongPressed;
    }
  }
  else {
    if (!_stateS) {
      if ((currTime - _prevTime) > DEBOUNCE_DELAY) {
        _prevTime = currTime;
        _stateS = HIGH;
        if (_stateL) res = bsPressed; 
      }
    }
  }  

  return res;  
}

